// FILE: AddArray.cpp
// STORES THE SUM OF a[i] AND b[i] IN c[i]
#include <iostream>
using namespace std;

void addArray(int, const float[], const float[], float[]);

int main()
{
   float a[] = {3, 4, 5};
   float b[] = {5, 5, 7};
   float c[3];

   addArray(3, a, b, c);

   for (int i = 0; i < 3; i++)
     cout << c[i] << "  ";
   cout << endl;

   return 0;
}

// Array elements with subscripts ranging from 0 to size-1
//    are summed element by element.
// Pre:  a[i] and b[i] are defined (0 <= i <= size-1
// Post: c[i] = a[i] + b[i] (0 <= i <= size-1)
void addArray
  (int size,                   // IN: the size of the three arrays
   const float a[],            // IN: the first array
   const float b[],            // IN: the second array
   float c[])                  // OUT: result array
{
   // Add corresponding elements of a and b and store in c.
   for (int i = 0; i < size; i++)
      c[i] = a[i] + b[i];
}  // end addArray

