// File: oilSupply.cpp
// Displays daily usage and amount left in oil tank.

#include <iostream>
using namespace std;

const float CAPACITY = 10000;	// tank capacity
const float MINPCT = 10.0; 	// minimum percent

float monitorOil(float, float);

int main()
{
   float supply; 	// input - initial oil supply
   float oilLeft;       // output - oil left in tank
   float minOil;       	// minimum oil supply

   // Get the initial oil supply.
   cout << "Enter initial oil supply: ";
   cin >> supply;

   // Compute the minimum oil supply.
   minOil = CAPACITY * (MINPCT / 100.0);

   // Compute and display the amount of oil left each day.
   oilLeft = monitorOil(supply, minOil);

   // Display a warning message if supply is less than minimum
   cout << endl << oilLeft << " gallons left in tank." << endl;
   if (oilLeft < minOil)
      cout << "Warning - amount of oil left is below minimum!" << endl;

   return 0;
}

float monitorOil(float supply, float minOil)
{
   // Local data . . .
   float usage;         // input from user - Each day's oil use
   float oilLeft;	// Amount left each day

   oilLeft = supply;
   while (oilLeft > minOil) {
      cout << "Enter amount used today: ";
      cin >> usage;
      oilLeft -= usage;
      cout << "After removal of " << usage << " gallons,"
           << endl;
      cout << "number of gallons left is " << oilLeft
           << endl << endl;
   }

   return oilLeft;
}   
