// File: ReadScores.cpp
// Reads an array of exam scores for a lecture section
//    of up to max_size students.

#include <iostream>
using namespace std;

void readScores
  (int scores[],        // OUT: array to contain all scores read
   const int MAX_SIZE,  // IN: max size of array scores
   int& sectionSize);    // OUT: number of elements read

int main()
{
  int scores[100];
  int size;

  readScores(scores, 5, size);
  for (int i = 0; i < size; i++)
     cout << scores[i] << "  " ;
  cout << endl;

  return 0;
}

// Pre:  None
// Post: The data values are stored in array scores.
//       The number of values read is stored in sectionSize.
//       (0 <= sectionSize < MAX_SIZE).
void readScores
  (int scores[],        // OUT: array to contain all scores read
   const int MAX_SIZE,  // IN: max size of array scores
   int& sectionSize)    // OUT: number of elements read
{
   // Local data ...
   const int SENTINEL = -1;   // sentinel value
   int tempScore;             // temporary storage for each score 

   // Read each array element until done.
   cout << "Enter next score after the prompt or enter "
        << SENTINEL << " to stop." << endl;
   sectionSize = 0;           // initial class size
   cout << "Score: ";
   cin >> tempScore;
   while ((tempScore != SENTINEL) && (sectionSize < MAX_SIZE))
   {
      scores[sectionSize] = tempScore;  // save score just read
      sectionSize++;
      cout << "Score: ";
      cin >> tempScore;
   }  // end while

   // Sentinel was read or array is filled.
   if (tempScore != SENTINEL)
   {
      cout << "Array is filled!" << endl;
      cout << tempScore << " not stored" << endl;
   }
}

