// File: ReadScoresFile.cpp
// Reads an array of exam scores for a lecture section
//    of up to max_size students.

#include <iostream>
#include <fstream>
using namespace std;

#define inFile "Scores.txt"

void readScoresFile
  (ifstream& ins,
  int scores[],        // OUT: array to contain all scores read
   const int MAX_SIZE,  // IN: max size of array scores
   int& sectionSize);    // OUT: number of elements read

int main()
{
  int scores[100];
  int size;
  ifstream ins;

  ins.open(inFile);
  if (ins.fail())
  {
     cout << "Error" << endl;
     return 1;
  }
  readScoresFile(ins, scores, 5, size);
  for (int i = 0; i < size; i++)
     cout << scores[i] << "  " ;
  cout << endl;
  
  return 0;
}

// File: ReadScoresFile.cpp
// Reads an array of exam scores for a lecture section
//    of up to MAX_SIZE students from a file.

// Pre:  None
// Post: The data values are read from a file and stored 
//       in array scores.
//       The number of values read is stored in sectionSize.
//       (0 <= sectionSize < MAX_SIZE).
void readScoresFile
  (ifstream& ins,       // IN:  input stream of scores
   int scores[],        // OUT: array to contain all scores read
   const int MAX_SIZE,  // IN: max size of array scores
   int& sectionSize)    // OUT: number of elements read
{
   // Local data ...
   int tempScore;             // temporary storage for each score

   // Read each array element until done.
   sectionSize = 0;           // initial class size
   ins >> tempScore;
   while (!ins.eof() && (sectionSize < MAX_SIZE))
   {
      scores[sectionSize] = tempScore;  // save score just read
      sectionSize++;
      ins >> tempScore;
   }  // end while

   // End of file reached or array is filled.
   if (!ins.eof())
   {
      cout << "Array is filled!" << endl;
      cout << tempScore << " not stored" << endl;
   }
}

