// File Savings.h
// Savings account class definition

#include "money.h"         // access money class
#include <string>          // access string class
using namespace std;

#ifndef SAVINGS_H
#define SAVINGS_H

class savings
{
   public:
      // Member Functions...
      // constructor
      savings();

      // Open a new account
      void openAccount();

      // Change account name
      void changeName(int, string);

      // Add quarterly interest
      void addInterest();

      // Process a deposit
      void deposit(int, money);

      // Process a withdrawal
      void withdraw(int, money);

      // Close an account
      void closeAccount(int);

      // Get account balance
      money getBalance() const;

   private:
      // Data members (attributes) 
      int id;
      string name;
      money balance;
      float interestRate;

      // Member functions...
      // Validate user identification
      bool validId(int) const;
};

#endif // SAVINGS_H
