// File: StackText.cpp
// Use a stack to store strings and display them in reverse order
 
#include "stack.h"        // Uses stack template class
#include <string>
#include <iostream>
using namespace std;

typedef stack<string, 20> stringStack;
 
int fillStack(stringStack& s);
void displayStack(stringStack& s);
 
int main()
{
   // Local data
   stringStack s;
 
   // Read data into the stack.
   fillStack(s);
 
   // Display the stack contents
   displayStack(s);
   
   return 0;
}


//    Reads data characters and pushes them onto stack s.
//    Pre : s is an empty stack.
//    Post: s contains the strings read in reverse order.
//    Returns the number of strings read not counting the sentinel.

int fillStack(stringStack& s)   // OUT: stack to fill
{
   // Local data
      string nextStr;          // next string
      int numStrings;          // count of strings read
      const string sentinel = "***";  // sentinel string

   // Read and push strings onto stack until done.
   numStrings = 0;
   cout << "Enter next string or " << sentinel << "> ";
   cin >> nextStr;
   while ((nextStr != sentinel) && (!s.isFull()))
   {
      s.push (nextStr);  // Push next string on stack S.
      numStrings++;
      cout << "Enter next string or " << sentinel << "> ";
      cin >> nextStr;
   }

   return numStrings;
}  // end fillStack


//    Pops each string from stack s and displays it.
//    Pre : Stack s is defined.
//    Post: Stack s is empty and all strings are displayed.

void displayStack(stringStack& s)  // IN: stack to display
{
   // Local data
   string nextStr;

   // Pop and display strings until stack is empty.
   while (!s.isEmpty())
   {
      s.pop(nextStr);   // Pop next string off.
      cout << nextStr << endl;
   }
}  // end displayStack

