// File circle.cpp
// Circle class implementation

#include "circle.h"
#include <iostream>
using namespace std;

const float pi = 3.14159;

// Member Functions...
// constructor
circle::circle()
{
   x = 0;
   y = 0;
   radius = 0;
   cColor = nocolor;
   area = 0.0;
   perimeter = 0.0;
}

// Set center position
void circle::setCoord(int xArg, int yArg)
{
   x = xArg;
   y = yArg;
}


// Set radius
void circle::setRadius(float r)
{
   radius = r;
   computeArea();
   computePerimeter();
}


// Set color
void circle::setColor(color c)
{
   cColor = c;
}


// Compute the area
void circle::computeArea()
{
   area = pi * radius * radius;
}


// Compute the perimeter
void circle::computePerimeter()
{
   perimeter = 2 * pi * radius;
}


// Display attributes
void circle::displayCircle() const
{
   cout << "x-coordinate is " << x << endl;
   cout << "y-coordinate is " << y << endl;
   cout << "color is " << int(cColor) << endl;
   cout << "area is " << area << endl;
   cout << "perimeter is " << perimeter << endl;
}


// accessor functions
circle::color circle::getColor() const
{
   return cColor;
}

//    Insert definitions for rest of accessor functions here.
//       ...

int circle::getX() const
{  return x;
}

int circle::getY() const
{  return y;
}

float circle::getRadius() const
{  return radius;
}

float circle::getArea() const
{  return area;
}

float circle::getPerimeter() const
{  return perimeter;
}
