// File circle.h
// Circle class definition

#ifndef CIRCLE_H
#define CIRCLE_H

class circle
{
   public:
      // enumeration type
      enum color {black, blue, green, cyan, red,
                  magenta, brown, lightgray, nocolor};

      // Member Functions
      // constructor
      circle();

      // Set center coordinates
      void setCoord(int, int);

      // Set radius
      void setRadius(float);

      // Set color
      void setColor(color);

      // Compute the area
      void computeArea();

      // Compute the perimeter
      void computePerimeter();

      // Display attributes
      void displayCircle() const;

      // accessor functions
      int getX() const;
      int getY() const;
      float getRadius() const;
      color getColor() const;
      float getArea() const;
      float getPerimeter() const;

   private:
      // Data members (attributes) 
      int x;
      int y;
      float radius;
      color cColor;
      float area;
      float perimeter;
};

#endif // CIRCLE_H
