// File: color.cpp
// Tests the enumeration type color.
#include <iostream>
using namespace std;

enum color {red, green, yellow, blue};

// Function prototypes
void writeColor(color);

color readColor();

int main()
{
        color eyeColor, hairColor;

        cout << "Reading eye color" << endl;
        eyeColor = readColor();
        cout << endl << "Reading hair color" << endl;
        hairColor = readColor();

        cout << "Eye color is ";
        writeColor(eyeColor);
        cout << ", hair color is ";
        writeColor(hairColor);
        cout << endl;

        return 0;
}

// Reads the value of thisColor
// Returns the color value corresponding to a data character.
color readColor()
{
   // Local data ...
   char colorChar;          // storage for data character

   // Loop until a valid character is read.
   do
   {
      cout << "Enter first letter of color (R, G, B, or Y): ";
      cin >> colorChar;
      colorChar = toupper(colorChar);  // to uppercase

      // Return color value if valid character read.
      switch(colorChar)
      {
         case 'R' : return red;
         case 'G' : return green;
         case 'B' : return blue;
         case 'Y' : return yellow;
         default  : cout << "Try again!" << endl;
      } // end Switch
   } while (true);
}

// Displays the value of thisColor
// Pre : thisColor is assigned a value.
// Post: The value of thisColor is displayed as a string
void writeColor
  (color thisColor)    // IN: color to display as string
{
   // Display color value as a string.
   switch (thisColor)
   {
      case red:
         cout << "red";
         break;
      case green:
         cout << "green";
         break;
      case blue:
         cout << "blue";
         break;
      case yellow:
         cout << "yellow";
         break;
      default:
         cout << "*** ERROR: Invalid color for value."
              << endl;
   }
}
