// File: computeSumAve.cpp
// Computes and prints the sum and average of a collection of data.
// File: computeSumAveFunctions
// Computes the sum and average of a collection of data

#include <iostream>
using namespace std;

// Functions used ...
// Computes sum of data
float computeSum
  (int);               // IN: number of data items

// Computes average of data
float computeAve
  (int,                // IN: number of data items
   float);             // IN: sum of data items

// Prints number of items, sum, and average
void printSumAve
  (int,                // IN: number of data items
   float,              // IN: sum of the data
   float);             // IN: average of the data

int main()
{
   // Local data . . .
   int numItems;       // input: number of items to be added
   float sum;          // output: accumulated sum of data
   float average;      // output: average of data being processed

   // Read the number of items to process.
   cout << "Enter the number of items to process:";
   cin >> numItems;

   // Compute the sum of the data.
   sum = computeSum(numItems);

   // Compute the average of the data.
   average = computeAve(numItems, sum);

   // Print the sum and the average.
   printSumAve(numItems, sum, average);

   return 0;
}

// Insert definitions for functions computeSum, computeAve,
//   and printSumAve here.
// Computes sum of data.
// Pre:  numItems is assigned a value.
// Post: numItems data items read; their sum is stored in sum.
// Returns: Sum of all data items read if numItems >= 1;
//          otherwise, 0.

float computeSum
  (int numItems)    // IN: number of data items
{
   // Local data ...
   float item;       // input:  contains current data item
   float sum;        // output: used to accumulate sum of data
                     //         read in
 
   // Read each data item and accumulate it in sum.
   sum = 0.0;
   for (int count = 0; count < numItems; count++)
   {
      cout << "Enter a number to be added: ";
      cin >> item;
      sum += item;
   }  // end for
 
 
   return sum;
}  // end computeSum
// Computes average of data
// Pre:  numItems and sum are defined; numItems must be
//       greater than 0.
// Post: If numItems is positive, the average is computed as
//       sum / numItems;
// Returns: The average if numItems is positive; otherwise, 0.

float computeAve
  (int numItems,      // IN: number of data items
   float sum)         // IN: sum of data
{
// Compute the average of the data.
   if (numItems < 1)              // test for invalid input
   {
      cout << "Invalid value for numItems = " << numItems
           << endl;
      cout << "Average not computed." << endl;
      return 0.0;               // return for invalid input
   }  // end if
   return sum / numItems;
}  // end computeAve
// Prints number of items, sum, and average of data
// Pre:  numItems, sum, and average are defined.
// Post: Displays numItems, sum and average if numItems > 0.

void printSumAve
  (int numItems,          	// IN: number of data items
   float sum,               	// IN: sum of the data
   float average)            	// IN: average of the data
{
   // Display results if numItems is valid.
   if (numItems > 0)
   {
      cout << "The number of items is " << numItems << endl;
      cout << "The sum of the data is " << sum << endl;
      cout << "The average of the data is " << average << endl;
   }
   else
   {
      cout << "Invalid number of items = " << numItems << endl;
      cout << "Sum and average are not defined." << endl;
      cout << "No printing done.  Execution terminated." << endl;
   }  // end if
}  // end printSumAve


