// File: entry.cpp
// Implementation file for class entry
 
#include "entry.h"
#include <iostream>
#include <string>
using namespace std;
 
// constructor
entry::entry()
{
   name = "";
   number = "";
}

// Store data in an entry
void entry::setEntry(const string& na,     // IN: name
                     const string& nr)     // IN: number
{
   name = na;
   number = nr;
}

// Get name
string entry::getName() const
{
   return name;
}

// Get number
string entry::getNumber() const
{
   return number;
}


// Operators 
/*
bool entry::operator == (const entry& dE)   // IN: right-operand
{
   return (name == dE.name);
}
*/
bool operator == (const entry& dE1, const entry&dE)   // IN: right-operand
{
   return (dE1.getName() == dE.getName());
}

bool entry::operator < (const entry& dE)   // IN: right-operand
{
   return (name < dE.getName());
}


bool entry::operator > (const entry& dE)   // IN: right-operand
{
   return (name > dE.getName());
}


// friends
ostream& operator << (ostream& outs,    // INOUT: stream
                      const entry& dE) 	// IN: entry displayed
{
   outs << "Name   is " << dE.getName() << endl;
   outs << "Number is " << dE.getNumber() << endl;

   return outs;
}


istream& operator >> (istream& ins, 	// INOUT: stream
                      entry& dE)   	// OUT: entry read
{
   cout << "Enter name: ";
   getline(ins, dE.getName(), '\n');
   cout << "Enter number: ";
   ins >> dE.getNumber();

   return ins;
}

