// File: findSumTest.cpp
// Program and recursive function to sum an array's elements

#include <iostream>
using namespace std;

// Function prototype 
int findSum(int[], int);
int binSearch(int[], int, int, int);

int main()
{
   const int SIZE = 10;
   int x[SIZE];                // array of 10 elements
   int sum1;                   // result of recursive sum
   int sum2;                   // calculated sum

   // Fill array x
   for (int i = 0; i < SIZE; i++)
      x[i] = i + 1;            // Store 1, 2, 3,   

   // Calulate sum two ways
   sum1 = findSum(x, SIZE);
   sum2 = (SIZE * (SIZE + 1)) / 2;

   cout << "Recursive sum is " << sum1 << endl;
   cout << "Calculated sum is " << sum2 << endl;

   cout << binSearch(x, 10, 10, SIZE-1) << endl;
   
   return 0;
}


// Finds the sum of integers in an n-element array
int findSum(int x[], int n)
{
   if (n == 1)
      return x[0];                    // stopping case
   else
      return x[n-1] + findSum(x, n-1);  // recursive step
}

// Searches for target in elements first through last of array
//   Precondition : The elements of table are sorted &
//                  first and last are defined.
//   Postcondition: If target is in the array, return its
//                  position; otherwise, returns -1.
int binSearch (int table[],  // IN: array being searched
               int target,   // IN: target element
               int first,    // IN: first element to search
               int last)     // IN: last element to search
{
	int middle;

        middle = (first + last) / 2;     // middle of array

	if (first > last)            
		return -1;                  // unsuccessful search
	else if (target == table[middle])
		return middle;              // successful search
	else if (target < table[middle])
		return binSearch(table, target, first, middle-1);
	else  // search upper half of array
		return binSearch(table, target, middle+1, last);
}


