// File: Fraction.cpp
// Fraction class implementation

#include "fraction.h"
#include <iostream>
using namespace std;

// Member functions
// Constructors
fraction::fraction()
{
   num = 0;
   denom = 0;
}

fraction::fraction(int n)
{
   num = n;
   denom = 1;
}

fraction::fraction(int n, int d)
{
   num = n;
   denom = d;
}

// Set numerator and denominator
void fraction::setNum(int n)
{
   num = n;
}

void fraction::setDenom(int d)
{
   denom = d;
}
// Multiply fractions
fraction fraction::multiply(const fraction& f)
{
   fraction temp(num * f.num, denom * f.denom);
   return temp;
}

// Divide fractions
fraction fraction::divide(const fraction& f)
{
   fraction temp(num * f.denom, denom * f.num);
   return temp;
}

// Add fractions
fraction fraction::add(const fraction& f)
{
   fraction temp(num * f.denom + f.num * denom,
                 denom * f.denom);
   return temp;
}

// Subtract Fractions
fraction fraction::subtract(const fraction& f) {
   fraction temp(num * f.denom - f.num * denom,
                 denom * f.denom);
   return temp;
}

// Read a fraction
void fraction::readFrac()
{
   char slash;       // storage for /
   do
   {
      cout << "Enter numerator / denominator: ";
      cin >> num >> slash >> denom;
   }
   while (slash != '/');
}

// Display a fraction
void fraction::displayFrac() const
{
   cout << num << '/' << denom;
}

// Accessors
int fraction::getNum() const
{
   return num;
}

fraction fraction::operator + (const fraction& f2)   // IN: right-operand
{
   fraction temp(num * f2.denom + f2.num * denom,
                 denom * f2.denom);
   return temp;
}

bool fraction::operator == (const fraction& f)
{
   return(num == f.num && denom == f.denom);
}

int fraction::getDenom() const
{
   return denom;
}

