// File: Fraction.h
// Fraction class definition

#ifndef FRACTION_H
#define FRACTION_H

class fraction
{
   public:
	// Member functions
	// Constructors
	fraction();
	fraction(int);
	fraction(int, int);

	// Set numerator and denominator
	void setNum(int);
	void setDenom(int);

	// Multiply fractions
	fraction multiply(const fraction& f);

	// Divide fractions
	fraction divide(const fraction& f);

	// Add Fractions
	fraction add(const fraction& f);

	// Subtract Fractions
	fraction subtract(const fraction& f);

	// Read a fraction
	void readFrac();

	// Display a fraction
	void displayFrac() const;

	// Accessors
	int getNum() const;
	int getDenom() const;

        fraction operator + (const fraction&);
        bool operator == (const fraction&);

   private:
	// Data members (attributes)
	int num;	//  private data field
	int denom;	// private data field
};

#endif // FRACTION_H
