// FILE: gcdTest.cpp
// Program and recursive function to find greatest common divisor

#include <iostream>
using namespace std;

// Function prototype 
int gcd(int, int);

int main()
{
   int m, n; 	// the two input items

   cout << "Enter two positive integers: ";
   cin >> m >> n;
   cout << endl;
   cout << "Their greatest common divisor is " << gcd(m, n) 
        << endl;
   
   return 0;
}


// Finds the greatest common divisor of two integers
// Pre:     m and n are defined and both are > 0.
// Post:    None
// Returns: The greatest common divisor of m and n.

int gcd(int m, int n)  
{
   if (m < n)
      return gcd(n, m);      // transpose arguments
   else if (m % n == 0)
      return n;              // n is GCD
   else
      return gcd(n, m % n);  // recursive step
}

