// File: testMoneyToNumber.cpp
// Tests function moneyToNumberString
#include <string>
#include <iostream>
using namespace std;

// Function prototype
void moneyToNumberString(string&);

int main()
{
   string mString;

   cout << "Enter a dollar amount with $ and commas: ";
   cin >> mString;

   moneyToNumberString(mString);

   cout << "The dollar amount as a number is " << mString
        << endl;
   
   return 0;
} 


// Removes the $ and commas from a money string.
// Pre: moneyString is defined and may contain commas and
//      begin with $ or -$.
// Post: $ and all commas are removed from moneyString.
void moneyToNumberString
  (string& moneyString) // INOUT - string with possible $ and commas
{
   // Local data . . .
   int posComma;      // position of next comma

   // Remove $ from moneyString
   if (moneyString.at(0) == '$')  // Starts with $ ?
      moneyString.erase(0, 1);    // Remove $
   else if (moneyString.find("-$") == 0)  // Starts with -$ ?
      moneyString.erase(1, 1);            // Remove $

   // Remove all commas
   posComma = moneyString.find(",");         // Find first ,
   while (posComma >= 0 &&
          posComma < moneyString.length())   // posComma valid?
   {
       moneyString.erase(posComma, 1);       // Remove ,
       posComma = moneyString.find(",");     // Find next ,
   }
}  // end moneyToNumberString

