// File: queue.cpp
// Implementation of template class queue

#include "queue.h"
#include <cstdlib>        // for NULL

//using namespace std;

      // Member functions 
      // constructor - create an empty queue
      template<class queueElement>
      queue<queueElement>::queue()
      {
         numItems = 0;
         front = NULL;
         rear = NULL;
      }


      // Insert an element into the queue
      // Pre : none
      // Post: If heap space is available, the value x is inserted
      //       at the rear of the queue and true is returned.
      //       Otherwise, the queue is not changed and false is
      //       returned.
      template<class queueElement>
      bool queue<queueElement>::insert
        (const queueElement& x)   // IN: Element to insert
      {
         if (numItems == 0)          // Test for empty queue
         {
            rear = new queueNode;    // Allocate first queue node
            if (rear == NULL)        // Check to see if allocated 
               return false;
            else
               front = rear;          // queue with one element
         }
         else                         // Add to existing queue
         {
            rear->next = new queueNode; // Connect new last node
            if (rear->next == NULL)
               return false;            // no node connected
            else
               rear = rear->next;       // Point rear to last node
         }
         rear->item = x;                // Store data in last node
         numItems++;
         return true;
      }  // end insert


      // Remove an element from the queue
      // Pre : none
      // Post: If the queue is not empty, the value at the front of
      //       the queue is removed, its value is placed in x, and
      //       true is returned. If the queue is empty, x is not
      //       defined and false is returned.
      template<class queueElement>
      bool queue<queueElement>::remove
        (queueElement& x)   // OUT: element removed
      {
         // Local data
         queueNode* oldFront;

         if (numItems == 0)          // Test for empty queue
         {
            return false;            // queue was empty
         }
         else                        // Remove first node
         {
            oldFront = front;  // Point oldFront to first node
            x = front->item;         // Retrieve its data
            front = front->next;     // Bypass old first node
            oldFront->next = NULL;   // Disconnect old first node 
            delete oldFront;         // Return its storage
            numItems--;              // Decrement queue size
            return true;
         }
      } // end remove


      // Test whether queue is empty
      template<class queueElement>
      bool queue<queueElement>::isEmpty()
      {
         return (numItems == 0);
      }


      // Returns queue size
      template<class queueElement>
      int queue<queueElement>::getSize()
      {
         return numItems;
      }

