// File: queueTest.cpp
// Use a queue to store strings and display them in reverse order
 
#include "queue.h"        // Uses Queue template class
#include <string>
#include <iostream>
using namespace std;

typedef queue<string> queueList;

int fillQueue(queueList& s);
void displayQueue(queueList& s);
 
int main()
{
   // Local data
   queueList s;

   // Read data into the queue.
   fillQueue(s);

   // Display the queue contents
	displayQueue(s);
	
   return 0;
}


//    Reads data characters and pushes them onto queue s.
//    Pre : s is an empty queue.
//    Post: s contains the strings read in reverse order.
//    Returns the number of strings read not counting the sentinel.

int fillQueue(queueList& s)   // OUT: queue to fill
{
   // Local data
      string nextStr;          // next string
      int numStrings;          // count of strings read
      const string sentinel = "***";  // sentinel string

   // Read and push strings onto queue until done.
   numStrings = 0;
   cout << "Enter next string or " << sentinel << "> ";
   cin >> nextStr;
   while ((nextStr != sentinel) )
   {
      s.insert (nextStr);  // Push next string on queue S.
      numStrings++;
      cout << "Enter next string or " << sentinel << "> ";
      cin >> nextStr;
   }

   return numStrings;
}  // end fillQueue


//    Pops each string from queue s and displays it.
//    Pre : Queue s is defined.
//    Post: Queue s is empty and all strings are displayed.

void displayQueue(queueList& s)  // IN: queue to display
{
   // Local data
   string nextStr;

   // Pop and display strings until queue is empty.
   while (!s.isEmpty())
   {
      s.remove(nextStr);   // Pop next string off.
      cout << nextStr << endl;
   }
}  // end displayQueue

