// File savings.cpp
// Savings account implementation file

#include "savings.h"
#include "money.h"
#include <string>
#include <iostream>
using namespace std;

// Member Functions...
// constructor
savings::savings()
{
   name = "";
   id = 0;
   balance = 0.0;
   interestRate = 0.0;
}


// Open a new account
void savings::openAccount()
{
   cout << "Account name: ";
   getline(cin, name, '\n');
   cout << "Account ID: ";
   cin >> id;
   cout << "Initial balance: $";
   cin >> balance;
   cout << "Annual interest rate percentage: %";
   cin >> interestRate;
}


// Validate user id
bool savings::validId(int ident) const
{
   if (id == ident)
      return true;
   else
   {
      cerr << "Error - ID's do not match! ";
      return false;
   }
}


// Change account name
void savings::changeName(int ident, string na)
{
   if (validId(ident))
   {
      name = na;
      cout << "Changing account name to " << na << endl;
   }
   else
      cerr << "Reject name change request." << endl;
}


// Add quarterly interest
void savings::addInterest()
{
   // Local data
   float quarter_rate_frac;           // quarterly rate as 
                                      //   a decimal fraction
   quarter_rate_frac = interestRate / 400.0;
   balance += balance * quarter_rate_frac;
}

// Process a deposit
void savings::deposit(int ident, money amount)
{
   if (validId(ident))
   {
      balance += amount;
      cout << "Depositing " << amount << endl;
   }
   else
      cerr << "Reject deposit of " << amount << endl;
}

// Process a withdrawal
void savings::withdraw(int ident, money amount)
{
   if ((validId (ident)) && (amount <= balance))
   {
      balance -= amount;
      cout << "Withdrawing " << amount << endl;
   }
   else
      cerr << "Reject withdrawal of " << amount << endl;
}


// Close an account
void savings::closeAccount(int ident)
{
   if (validId(ident))
   {
      cout << "Final balance for account number " << id
           << " is " << balance << endl;
      cout << "Account has been closed" << endl;
      balance = 0.0;
      id = 0;
      name = "";
   }
   else
      cerr << "Account not closed" << endl;
}


// Get account balance
money savings::getBalance() const
{
   return balance;
}