// File simplestring.cpp
// Simple string class implementation

#include "simplestring.h"
#include <iostream>
using namespace std;

// Member Functions...
// constructor
simpleString::simpleString()
{
   length = 0;    // Denotes an empty string
}


// Read a simple string
void simpleString::readString()
{
   // Local data...
   char next;              // input - next data character
   int pos = 0;            // subscript for array contents

   cin.get(next);         // Get first character from cin
   while ((next != '\n') && (pos < capacity))
   {
      // Insert next in array contents
      contents[pos] = next;
      pos++;
      cin.get(next);      // Get next character from cin
   }

   length = pos;           // Define length attribute
}


// Write a simple string
void simpleString::writeString() const
{
   for (int pos = 0; pos < length; pos++)
      cout << contents[pos];
}


// Retrieve the character at a specified position
//   Returns the character \0 if position is out of bounds
char simpleString::at(int pos) const  // IN: position of
                                        // character to get
{
   // Local data
   const char null_character = '\0';

   if ((pos < 0) || (pos >= length))
   {
       cerr << "Character at position " << pos
            << " not defined." << endl;
       return null_character;
   }
   else
      return contents[pos];
}


// Return the string length
int simpleString::getLength() const
{
   return length;
}

// Return the string capacity
int simpleString::getCapacity() const
{
   return capacity;
}

void simpleString::getContents(char str[]) const
{
   for (int i = 0; i < length; i++)
      str[i] = contents[i];
}