// File vectorTest.cpp
// Tests some vector operations

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main()
{
   vector <int> intVec(10);   // vector of 10 int elements with value 0
   vector <float> hours(5, 0.5); // vector of 5 float elements, value 0.5

   // Store the square of its subscript in each vector element
   for (int i = 0; i < intVec.size(); i++)
      intVec[i] = i * i;

   // Make a copy of intVec and display its values.
   vector <int> intVecCopy(intVec);
   cout << "Vector of cubes: ";
   for (int i = 0; i < intVec.size(); i++)
      cout << intVecCopy[i] << " ";
   cout << endl;

   // Initialize a vector to values stored in an array and display it.
   float values[10] = {5.5, 6.5, 8.0, -10.0, -5, 4, 6.8, 9.5, 10.5, 15};
   vector <float> myValues(values, values + 10); // copy from values to myValues
   cout << "Vector of floats: ";
   for (int i = 0; i < myValues.size(); i++)
      cout << myValues[i] << " ";
   cout << endl;

   // Change vector myValues[9] and add 3 values
   myValues.pop_back();
   myValues.push_back(999.9);
   myValues.push_back(5);
   myValues.push_back(11.5);
   myValues.push_back(25.0);
   cout << "Vector after changes: ";
   for (int i = 0; i < myValues.size(); i++)
      cout << myValues[i] << " ";
   cout << endl;

   // Sort vector myValues.
   sort(myValues.begin(), myValues.end());

   // Read a target and search for it using an iterator
   vector <float>::iterator index;         // iterator
   float target;                          // value to search for
   cout << "Enter value to search for: ";
   cin >> target;
   index = find(myValues.begin(), myValues.end(), target);
   if (index != myValues.end())
       cout << *index << " found in the vector." << endl;
   else
       cout << target << " not found!" << endl;

   // Insert a new 5th element and display vector myValues
   myValues.insert(myValues.begin() + 4, -777);
   cout << "Vector after sort: ";
   for (index = myValues.begin(); index != myValues.end(); index++)
      cout << *index << " ";
   cout << endl;

	return 0;
}

