// File: washers
// Computes the weight of a batch of flat washers.

#include <iostream>
using namespace std;

int main()
{
      const float PI = 3.14159;
      float holeDiameter; // input - diameter of hole
      float edgeDiameter; // input - diameter of outer edge   
      float thickness;    // input - thickness of washer      
      float density;      // input - density of material used 
      float quantity;     // input - number of washers made   
      float weight;       // output - weight of washer batch  
      float holeRadius;   // radius of hole                   
      float edgeRadius;   // radius of outer edge             
      float rimArea;      // area of rim                      
      float unitWeight;   // weight of 1 washer               

      // Get the inner diameter, outer diameter, and thickness.
      cout << "Inner diameter in centimeters: ";
      cin >> holeDiameter;
      cout << "Outer diameter in centimeters: ";
      cin >> edgeDiameter;
      cout << "Thickness in centimeters: ";
      cin >>  thickness;

      // Get the material density and quantity manufactured. 
      cout << "Material density in grams per cubic centimeter: ";
      cin >>  density;
      cout << "Quantity in batch: ";
      cin >> quantity;

      // Compute the rim area. 
      holeRadius = holeDiameter / 2.0;
      edgeRadius = edgeDiameter / 2.0;
      rimArea = PI * edgeRadius * edgeRadius - 
                 PI * holeRadius * holeRadius;

      // Compute the weight of a flat washer. 
      unitWeight = rimArea * thickness * density;
 
      // Compute the weight of the batch of washers. 
      weight = unitWeight * quantity;
 
      // Display the weight of the batch of washers. 
      cout << "The expected weight of the batch is " << weight;
      cout << " grams." << endl;

      return 0;
}

 